/* @(#)src/common/kernel/base/vx_sysmacros.h	3.11 08 Aug 1997 13:55:07 -  */
/* #ident "@(#)vxfs:src/common/kernel/base/vx_sysmacros.h	3.11" */

/*
 * Copyright (c) 1997 VERITAS Software Corporation.  ALL RIGHTS RESERVED.
 * UNPUBLISHED -- RIGHTS RESERVED UNDER THE COPYRIGHT
 * LAWS OF THE UNITED STATES.  USE OF A COPYRIGHT NOTICE
 * IS PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION
 * OR DISCLOSURE.
 *
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND
 * TRADE SECRETS OF VERITAS SOFTWARE.  USE, DISCLOSURE,
 * OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
 * EXPRESS WRITTEN PERMISSION OF VERITAS SOFTWARE.
 *
 * 		RESTRICTED RIGHTS LEGEND
 * USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS
 * SUBJECT TO RESTRICTIONS AS SET FORTH IN SUBPARAGRAPH
 * (C) (1) (ii) OF THE RIGHTS IN TECHNICAL DATA AND
 * COMPUTER SOFTWARE CLAUSE AT DFARS 252.227-7013.
 * 		VERITAS SOFTWARE
 * 1600 PLYMOUTH STREET, MOUNTAIN VIEW, CA 94043
 */

#ifndef	_FS_VXFS_VX_SYSMACROS_H
#define	_FS_VXFS_VX_SYSMACROS_H

/*
 * Is x a power of 2
 */

#define	VX_ISPOWER2(x)	(!((x) & ((x) - 1)))

/*
 * Offset from high order bit of the leftmost bit in a byte.
 */

#define	VX_LEFTBIT(x)	(vx_firstbit[(x)] >> 4)

/*
 * Offset from low order bit of the rightmost bit in a byte.
 */

#define	VX_RIGHTBIT(x)	(vx_firstbit[(x)] & 0xf)

/*
 * Macro that computes the log base 2 of x.
 */

#define	VX_LOG2(x)							  \
	(((unsigned)(x) < 256) ?  (7 - VX_LEFTBIT((unsigned)(x))) :	  \
       ((unsigned)(x) < 65536) ? (15 - VX_LEFTBIT((unsigned)(x) >> 8)) :  \
    ((unsigned)(x) < 16777216) ? (23 - VX_LEFTBIT((unsigned)(x) >> 16)) : \
				 (31 - VX_LEFTBIT((unsigned)(x) >> 24)))

/*
 * round x up to the the next boundary (bnd) where bnd is a power of 2.
 */

#define	VX_ROUNDUP(x, bnd)	\
	(((x) + ((bnd) - 1)) & ~(((long)(bnd) - 1)))

#endif /* _FS_VXFS_VX_SYSMACROS_H */
